# Class CIM_BGPService
extends CIM_RouteCalculationService

This class is used to represent the basic operation of BGP. It is derived from RouteCalculationService, the superclass of all routing protocols.

### Table of Contents
Hierarchy
Direct Known Subclasses
Class Qualifiers
Class Properties
Class Methods

## Class Hierarchy

CIM_ManagedElement
|
+--CIM_ManagedSystemElement
|
+--CIM_LogicalElement
|
+--CIM_EnabledLogicalElement
|
+--CIM_Service
|
+--CIM_NetworkService
|
+--CIM_RouteCalculationService
|
+--CIM_BGPService

## Direct Known Subclasses

## Class Qualifiers

Name | Data Type | Value
--- | --- | ---
Description | string | This class is used to represent the basic operation of BGP. It is derived from RouteCalculationService, the superclass of all routing protocols.
UMLPackagePath | string | CIM::Network::BGP
Version | string | 2.7.0

## Class Properties

### Local Class Properties

Name | Data Type | Default Value | Qualifiers
--- | --- | --- | ---
Name | Data Type | Value
BGPVersion | uint8 |
Description | string | The BGPVersion property defines the version of BGP that this router is using. This is part of the BGP peer negotiation process).
MappingStrings | string | MIB.IETF|BGP4-MIB.bgpVersion
LastErrorCode | uint16 |
Description | string | BGP sends errors using a NOTIFICATION message. This message contains an error code, an error subcode, and error data. The error code defines the type of the notification. The 'Cease' error is for all fatal errors that are not one of the other five types of errors. For several of the errors, subcode information is also enumerated in other properties of this class.
ValueMap | string | 0, 1, 2, 3, 4, 5, 6
Values | string | None, Message Header Error, OPEN Message Error, UPDATE Message Error, Hold Timer Expired, Finite State Machine Error, Cease
LastMessageErrorSubCode | uint16 |
Description | string | This defines the BGP error subcode for message header errors (LastErrorCode = 1). If LastErrorCode is any other value, then this property should be set to NULL.
ValueMap | string | 0, 1, 2, 3
Values | string | None, Connection Not Synchronized, Bad Message Length, Bad Message Type
LastOpenErrorSubCode | uint16 |
Description | string | This defines the BGP error subcode for OPEN message errors (LastErrorCode = 2). If LastErrorCode is any other value, then this property should be set to NULL.
ValueMap | string | 0, 1, 2, 3, 4, 5, 6
Values | string | None, Unsupported Version Number, Bad Peer AS, Bad BGP Identifier, Unsupported Optional Parameter, Authentication Failure, Unacceptable Hold Time
LastUpdateErrorSubCode | uint16 |
Description | string | This defines the BGP error subcode for UPDATE message errors (LastErrorCode = 3). If LastErrorCode is any other value, then this property should be set to NULL.
ValueMap | string | 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11
Values | string | None, Malformed Attribute List, Unrecognized Well-Known Attribute, Missing Well-Known Attribute, Attribute Flags Error, Attribute Length Error, Invalid Origin Attribute, AS Routing Loop, Invalid NEXT_HOP Attribute, Optional Attribute Error, Invalid Network Field, Malformed AS_path

### Inherited Properties

Name | Data Type | Class Origin
--- | --- | ---
AlgorithmType | uint16 | CIM_RouteCalculationService
Caption | string | CIM_ManagedElement
CommunicationStatus | uint16 | CIM_ManagedSystemElement
CreationClassName | string | CIM_Service
Description | string | CIM_ManagedElement
DetailedStatus | uint16 | CIM_ManagedSystemElement
ElementName | string | CIM_ManagedElement
EnabledDefault | uint16 | CIM_EnabledLogicalElement
EnabledState | uint16 | CIM_EnabledLogicalElement
HealthState | uint16 | CIM_ManagedSystemElement
InstallDate | datetime | CIM_ManagedSystemElement
InstanceID | string | CIM_ManagedElement
Name | string | CIM_Service
OperatingStatus | uint16 | CIM_ManagedSystemElement
OtherEnabledState | string | CIM_EnabledLogicalElement
PrimaryOwnerContact | string | CIM_Service
PrimaryOwnerName | string | CIM_Service
PrimaryStatus | uint16 | CIM_ManagedSystemElement
RequestedState | uint16 | CIM_EnabledLogicalElement
RouterID | string | CIM_RouteCalculationService
ServiceURL | string | CIM_NetworkService
Started | boolean | CIM_Service
StartMode | string | CIM_Service
Status | string | CIM_ManagedSystemElement
SystemCreationClassName | string | CIM_Service
SystemName | string | CIM_Service
TimeOfLastStateChange | datetime | CIM_EnabledLogicalElement
TransitioningToState | uint16 | CIM_EnabledLogicalElement
AvailableRequestedStates | uint16[] | CIM_EnabledLogicalElement
Keywords | string[] | CIM_NetworkService
OperationalStatus | uint16[] | CIM_ManagedSystemElement
StartupConditions | string[] | CIM_NetworkService
StartupParameters | string[] | CIM_NetworkService
StatusDescriptions | string[] | CIM_ManagedSystemElement

## Class Methods

### Inherited Class Methods

Name | Return Type | Class Origin
--- | --- | ---
RequestStateChange | uint32 | CIM_EnabledLogicalElement
StartService | uint32 | CIM_Service
StopService | uint32 | CIM_Service